PPW_Story_Andre/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('LandingPage.urls')),
    path('Story_1/', include('Story_1.urls')),
    path('Story_3/', include('Story_3.urls')),
    path('Story_5/', include('Story_5.urls')),
    path('Story_6/', include('Story_6.urls')),
    path('Story_7/', include('Story_7.urls')),
    path('Story_8/', include('Story_8.urls')),
    path('Story_9/', include('Story_9.urls')),
]

Story_1/urls.py
from django.contrib import admin
from django.urls import path
from .views import index

app_name = 'Story_1'

urlpatterns = [
    path('', index, name='Story_1-index'),
]

Story_9/urls.py
from django.urls import path
from .views import index, signup_page, auth_login, auth_logout, get_data

app_name = 'Story_9'

urlpatterns = [
    path('', index, name='Story_9-index'),
    path('signup/', signup_page, name = 'Story_9-signup'),
    path('login/', auth_login, name='Story_9-login'),
    path('logout/', auth_logout, name='Story_9-logout'),
    path('getdata', get_data, name = "Story_9-getdata")
]

Story_9/models.py
from django.db import models

# Create your models here.

Story_9/forms.py
from django import forms
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User

class SignupForm(UserCreationForm):
    class Meta:
        model = User
        fields = ['username', 'email', 'password1', 'password2']

Story_9/views.py
from django.shortcuts import render
from django.http import HttpResponseRedirect
from django.contrib.auth.models import User
from django.contrib.auth import authenticate, login, logout
from django.contrib import messages
from .forms import SignupForm
from django.http import JsonResponse
import requests

def index(request):
    return render(request, "Story_9/index.html", context = {})

def signup_page(request):
    if request.method == "POST":
        form = SignupForm(request.POST)
        if form.is_valid():
            form.save()
            user = form.cleaned_data.get("username")
            messages.success(request, 'Akun dengan username ' + user + " telah berhasil dibuat")
        else:
            messages.error(request, "Data input tidak valid")
        return HttpResponseRedirect('/Story_9/signup')
    else:
        context = {'form' : SignupForm()}
        return render(request, "Story_9/signupPage.html", context)

def auth_login(request):
    if request.method == "POST":
        username = request.POST.get('username')
        password = request.POST.get('password')
        user = authenticate(request, username = username, password = password)
        if user is not None:
            login(request, user)
            request.session['user_logged_username'] = username
            request.session['user_logged_email'] = user.email
            return HttpResponseRedirect('/Story_9')
        else:
            messages.error(request, "Username atau password salah")
            return HttpResponseRedirect('/Story_9/login')
    else:
        return render(request, "Story_9/loginPage.html", context = {})

def auth_logout(request):
    logout(request)
    return HttpResponseRedirect('/Story_9/')

def get_data(request):
    api_url = "https://www.googleapis.com/books/v1/volumes?q=" + request.GET['q']
    api_json = requests.get(api_url).json()
    return JsonResponse({'data' : api_json}, safe = False)

Story_9/templates/Story_9/index.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
    <title>Story 9 Andre</title>
    <link rel="stylesheet" type="text/css" href="{% static 'Story_9/style.css' %}" />
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <script src = "{% static 'jquery-3.5.1.min.js' %}"></script>
    <script src = "{% static 'Story_9/index.js' %}"></script>
{% endblock meta %}
{% block content %}
    <div id = "book-search" class = "d-flex flex-column justify-content-center align-items-center padding-3">
            <div class = "full-size d-flex justify-content-center align-items-center">
                <div class = "montserrat-bold large-font margin-1">
                    <p>Katalog</p>
                    <p style = "color: white;">sederhana</p>
                </div>
                <img src = "{% static 'Story_8/images/book.png' %}" alt = "Google Books logo" width = "150" height = "150">
            </div>
            {% if request.user.is_authenticated %}
            <p class = "montserrat-regular medium-font" style = "color: white;">Halo</p>
            <p class = "montserrat-bold semi-large-font primary-color">{{ request.session.user_logged_username }}</p>
            <a href="{% url 'Story_9:Story_9-logout' %}"><button type="button" class="btn btn-danger">Logout</button></a>
            <div class = "search-box">
                <input id = "search-input" type = "text" placeholder = "Masukkan kata kunci"/>
                <span></span>
            </div>
            <div id = "data" class = "d-flex full-size justify-content-center" style = "flex-wrap: wrap">
            </div>
            {% else %}
            <a href="{% url 'Story_9:Story_9-login' %}"><button type="button" class="btn btn-info">Log In</button></a>
            {% endif %}
    </div>
{% endblock content %}

Story_9/templates/Story_9/loginPage.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
    <title>Story 9 Andre</title>
    <link rel="stylesheet" type="text/css" href="{% static 'Story_9/style.css' %}" />
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
{% endblock meta %}
{% block content %}
    <div class = "d-flex flex-column justify-content-center align-items-center padding-3">
        <h1>Log In</h1>
        <form class = "full-size" action="" method="POST">
            {% csrf_token %}
            <div class = "full-size d-flex flex-column justify-content-center align-items-center">
                <div class = "full-size montserrat-medium medium-font margin-1">
                    <p>Username</p>
                    <input class = "full-size" type="text" name="username">
                </div>
            </div>
            <div class = "full-size d-flex flex-column justify-content-center align-items-center">
                <div class = "full-size montserrat-medium medium-font margin-1">
                    <p>Password</p>
                    <input class = "full-size" type="password" name="password">
                </div>
            </div>
            <button type="submit" value = "Submit" class="margin-top-2 btn btn-primary montserrat-deskripsi">Log In</button>
        </form>
        <div class = "full-size d-flex justify-content-center align-items-center">
            <div class = "full-size d-flex flex-column justify-content-center align-items-center montserrat-medium medium-font margin-1">
                {% for message in messages %}
                    <p>{{ message }}</p>
                {% endfor %}
            </div>
        </div>
        <div class = "full-size d-flex justify-content-center align-items-center">
            <div class = "full-size d-flex flex-column justify-content-center align-items-center montserrat-medium medium-font margin-1">
                <p>Belum memiliki akun?</p>
                <a href="{% url 'Story_9:Story_9-signup' %}">Sign Up</a>
            </div>
        </div>
    </div>
{% endblock content %}

Story_9/templates/Story_9/signupPage.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
    <title>Story 9 Andre</title>
    <link rel="stylesheet" type="text/css" href="{% static 'Story_9/style.css' %}" />
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
{% endblock meta %}
{% block content %}
    <div class = "d-flex flex-column justify-content-center align-items-center padding-3">
        <h1>Sign Up</h1>
        <form class = "full-size" action="" method="POST">
            {% csrf_token %}
            <div class = "full-size d-flex flex-column justify-content-center align-items-center">
                <div class = "full-size d-flex flex-column montserrat-medium medium-font margin-1">
                    <p class = "medium-font margin-top-2">Username</p>
                    {{ form.username }}
                </div>
            </div>
            <div class = "full-size d-flex flex-column justify-content-center align-items-center">
                <div class = "full-size d-flex flex-column montserrat-medium medium-font margin-1">
                    <p class = "medium-font margin-top-2">Email</p>
                    {{ form.email }}
                </div>
            </div>
            <div class = "full-size d-flex flex-column justify-content-center align-items-center">
                <div class = "full-size d-flex flex-column montserrat-medium medium-font margin-1">
                    <p class = "medium-font margin-top-2">Password</p>
                    {{ form.password1 }}
                </div>
            </div>
            <div class = "full-size d-flex flex-column justify-content-center align-items-center">
                <div class = "full-size d-flex flex-column montserrat-medium medium-font margin-1">
                    <p class = "medium-font margin-top-2">Password confirmation</p>
                    {{ form.password2 }}
                </div>
            </div>
            <button type="submit" value = "Submit" class="margin-top-2 btn btn-primary montserrat-deskripsi">Sign Up</button>
        </form>
        <div class = "full-size d-flex justify-content-center align-items-center">
            <div class = "full-size d-flex flex-column justify-content-center align-items-center montserrat-medium medium-font margin-1">
                {% for message in messages %}
                    <p>{{ message }}</p>
                {% endfor %}
            </div>
        </div>
        <div class = "full-size d-flex justify-content-center align-items-center">
            <div class = "full-size d-flex flex-column justify-content-center align-items-center montserrat-medium medium-font margin-1">
                <p>Sudah memiliki akun?</p>
                <a href="{% url 'Story_9:Story_9-login' %}">Login</a>
            </div>
        </div>
    </div>
{% endblock content %}